#!/usr/bin/perl

## --> Microwave Radio Path Analysis, path.cgi
## --> Green Bay Professional Packet Radio, www.gbppr.org

## This file Copyright 2003 <contact@gbppr.org> under the GPL.
## NO WARRANTY.  Please send bug reports / patches.

## Program Setup
#
$ENV{PATH} = "/bin:/usr/bin:/usr/local/bin";
select STDOUT;
$| = 1;
use Math::Trig;
use Math::Complex;
require "flush.pl";
$DEBUG = 1;

## User Setup
#
$logo = "../../../pics/gbppr.jpg";
$banner = "A service of Green Bay Professional Packet Radio - <a href=\"http://www.gbppr.org\">www.gbppr.org</a>";
$url = "http://gbppr.dyndns.org:8080/path.main.cgi";
$ver = "v1.26";
$splatdir = "/usr/splat/sdf";
$gnuplot = "/usr/local/bin/gnuplot";
$htmldoc = "/usr/bin/htmldoc";
$tail = "/usr/bin/tail";
$head = "/usr/bin/head";
$elev_tmp1 = "elev_tmp1";
$elev_tmp2 = "elev_tmp2";
$elev_tmp3 = "elev_tmp3";
$elev_tmp4 = "elev_tmp4";
$elev_tmp5 = "elev_tmp5";
$elev_tmp8 = "elev_tmp8";
$red = "<font color=red><b>";
$end = "</b></font>";

## Random Dir
#
($sec, $min, $hour, $mday, $mon, $year) = gmtime;
$mon  = sprintf "%02.0f", $mon + 1;
$mday = sprintf "%02.0f", $mday; 
$year = sprintf "%02.0f", $year;
$year = 1900 + $year;

$RAN = sprintf "%.f", rand(10000000);
mkdir "tmp/$mon-$mday";
mkdir "tmp/$mon-$mday/$RAN";
chdir "tmp/$mon-$mday/$RAN";
unlink <*>;
symlink $splatdir, "sdf";

## Print MIME
#
print "Content-type:text/html\n\n";
&flush(STDOUT);

## Read Environment
#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}

my $frq = $FORM{'frq'};
my $frq_val = $FORM{'frq_val'};

my $LAT1_D = $FORM{'LAT1_D'};
my $LAT1_M = $FORM{'LAT1_M'};
my $LAT1_S = $FORM{'LAT1_S'};

my $LON1_D = $FORM{'LON1_D'};
my $LON1_M = $FORM{'LON1_M'};
my $LON1_S = $FORM{'LON1_S'};

my $LAT2_D = $FORM{'LAT2_D'};
my $LAT2_M = $FORM{'LAT2_M'};
my $LAT2_S = $FORM{'LAT2_S'};

my $LON2_D = $FORM{'LON2_D'};
my $LON2_M = $FORM{'LON2_M'};
my $LON2_S = $FORM{'LON2_S'};

my $tx_ant_ht_val = $FORM{'tx_ant_ht_val'};
my $tx_ant_ht = $FORM{'tx_ant_ht'};

my $rx_ant_ht_val = $FORM{'rx_ant_ht_val'};
my $rx_ant_ht = $FORM{'rx_ant_ht'};

my $nth = $FORM{'nth'};

my $k = $FORM{'k'};

my $rain = $FORM{'rain'};

my $earcon = $FORM{'earcon'};
my $diecon = $FORM{'diecon'};
my $climate = $FORM{'climate'};
my $polar = $FORM{'polar'};
my $sit = $FORM{'sit'};
my $time = $FORM{'time'};

my $EE_DIS = $FORM{'EE_DIS'};
my $EE_HT = $FORM{'EE_HT'};
my $EE_TYPE = $FORM{'EE_TYPE'};

my $FF_DIS = $FORM{'FF_DIS'};
my $FF_HT = $FORM{'FF_HT'};
my $FF_TYPE = $FORM{'FF_TYPE'};

my $GG_DIS = $FORM{'GG_DIS'};
my $GG_HT = $FORM{'GG_HT'};
my $GG_TYPE = $FORM{'GG_TYPE'};

my $HH_DIS = $FORM{'HH_DIS'};
my $HH_HT = $FORM{'HH_HT'};
my $HH_TYPE = $FORM{'HH_TYPE'};

my $II_DIS = $FORM{'II_DIS'};
my $II_HT = $FORM{'II_HT'};
my $II_TYPE = $FORM{'II_TYPE'};

my $JJ_DIS = $FORM{'JJ_DIS'};
my $JJ_HT = $FORM{'JJ_HT'};
my $JJ_TYPE = $FORM{'JJ_TYPE'};

my $KK_DIS = $FORM{'KK_DIS'};
my $KK_HT = $FORM{'KK_HT'};
my $KK_TYPE = $FORM{'KK_TYPE'};

my $LL_DIS = $FORM{'LL_DIS'};
my $LL_HT = $FORM{'LL_HT'};
my $LL_TYPE = $FORM{'LL_TYPE'};

my $MM_DIS = $FORM{'MM_DIS'};
my $MM_HT = $FORM{'MM_HT'};
my $MM_TYPE = $FORM{'MM_TYPE'};

my $NN_DIS = $FORM{'NN_DIS'};
my $NN_HT = $FORM{'NN_HT'};
my $NN_TYPE = $FORM{'NN_TYPE'};

my $tx_name = $FORM{'tx_name'};
my $rx_name = $FORM{'rx_name'};

## Subroutines
#
sub System {
  if ((0xffff & system $args) != 0 ) {
    print STDERR "error: $!\n";
    exit 1;
  }
}

sub bynumber {
  $b <=> $a  
} 

sub bynumber1 {
  $a <=> $b
}

sub arccos {
  $result = 0;
  if ($y > 0) {
    $result = acos($x / $y);
  }
  if ($y < 0) {
    $result = pi + acos($x / $y);
  }
  return $result;
}

sub Obst {
  $azimuth = deg2rad $AZSP;
  $lat1 = deg2rad $LAT1;
  $lon1 = deg2rad $LON1;

  $beta = ($distance * 0.62137119) / 3959;
  $lat2 = asin(sin($lat1) * cos($beta) + cos($azimuth) * sin($beta) * cos($lat1));
  $num = cos($beta) - (sin($lat1) * sin($lat2));
  $den = cos($lat1) * cos($lat2);

  if ($azimuth == 0 && ($beta > ((pi / 2) - $lat1))) {
    $lon2 = $lon1 + pi;
  }
  elsif ($azimuth == (pi / 2) && ($beta > ((pi / 2) + $lat1))) {
    $lon2 = $lon1 + pi;
  }
  elsif (abs($num / $den) > 1) {
    $lon2 = $lon1;
  }
  else {
    if ((pi - $azimuth) >= 0) {
      $lon2 = $lon1 - arccos($x=$num, $y=$den);
    }
    else {
      $lon2 = $lon1 + arccos($x=$num, $y=$den);
    }
  }

  while ($lon2 < 0) {
    $lon2 += (pi * 2);
  }
  while ($lon2 > (pi * 2)) {
    $lon2 -= (pi * 2);
  }

  open OB, "> OB.qth";
    print OB  "OB\n";
    printf OB "%.6f\n", rad2deg $lat2;
    printf OB "%.6f\n", rad2deg $lon2;
    print OB  "0\n";
  close OB; 
							      
  open S, "/usr/local/bin/splat.elv -t OB.qth -r OB.qth -d sdf |";
    while (<S>) { 
      chomp;
      $OB_elev = $_ * 0.3048;
    }
  close S; 

  $OB_Ecorr = sprintf "%.2f", $OB_elev + (75.5 / $k) * 0.001 * $distance * ($dist_km - $distance);
									                   
  $OB_HT =~ tr/0-9.//csd;
															           
  if ($OB_TYPE eq "Tree") {
    printf G "set arrow from %s,%s to %s,%s lt -1 lw 2\n", $distance, $OB_Ecorr, $distance, $OB_Ecorr + $OB_HT;
    $type = "T";
  } 
  else {
    printf G "set arrow from %s,%s to %s,%s nohead lt -1 lw 3\n", $distance, $OB_Ecorr, $distance, $OB_Ecorr + $OB_HT;
    $type = "B";
  } 

  if ($tx_ant_ht_ov_ft > $rx_ant_ht_ov_ft) {
    $BIG = "yes";
  }
  else {
    $BIG = "no";
  }

  $OB_curv = (($distance * 0.62137119) * ($dist_mi - ($distance * 0.62137119))) / (1.5 * $k);

  if ($OB_curv < 0) {
    $OB_curv = 0;
  }

  if ($BIG eq "yes") {
    $A = ($distance * 0.62137119) * (($tx_ant_ht_ov_ft - $rx_ant_ht_ov_ft) / $dist_mi);
    $OB_sigclr = ($tx_ant_ht_ov_ft - $A) - (($OB_elev / 0.3048) + $OB_curv + ($OB_HT / 0.3048));
  }
  else {
    $A = ($distance * 0.62137119) * (($rx_ant_ht_ov_ft - $tx_ant_ht_ov_ft) / $dist_mi);
    $OB_sigclr = ($tx_ant_ht_ov_ft + $A) - (($OB_elev / 0.3048) + $OB_curv + ($OB_HT / 0.3048));
  }

  $OB_C = (($distance * 0.62137119) * ($dist_mi - ($distance * 0.62137119))) / ($frq_ghz * $dist_mi);

  if ($OB_C < 0) {
    $OB_C = 0;
  }

  $OB_frs = 72.1 * 0.6 * sqrt($OB_C);

  $OB_frsclr =  $OB_sigclr - $OB_frs;

  if ($OB_frs != 0) {
    $OB_ratio = $OB_sigclr / $OB_frs;
    $OB_ratio = sprintf "%.1f", $OB_ratio;
  }
  else {
    $OB_ratio = 0;
    $OB_ratio = sprintf "%.1f", $OB_ratio;
  }

  open OB, ">> path_obstruct.html";
    print OB "<tr>\n";
    printf OB "<td>%.2f</td>", $distance;
    printf OB "<td>%.1f</td>", $OB_elev;
    printf OB "<td>%.1f&nbsp;&nbsp;(%s)</td>", $OB_HT, $type;
    printf OB "<td>%.2f</td>", $OB_curv * 0.3048;

    if (($OB_sigclr * 0.3048) < 0) {
      printf OB "<td>%s%.1f%s</td>", $red, $OB_sigclr * 0.3048, $end;
    }
    else {
      printf OB "<td>%.1f</td>", $OB_sigclr * 0.3048;
    }
    
    push (@ADDITIONAL, ($OB_sigclr * 0.3048));
    printf OB "<td>%.1f</td>", $OB_frs * 0.3048;

    if (($OB_frsclr * 0.3048) < 0) {
      printf OB "<td>%s%.1f%s</td>", $red, $OB_frsclr * 0.3048, $end;
    }
    else {
      printf OB "<td>%.1f</td>", $OB_frsclr * 0.3048;
    }

    push (@ADDITIONAL, ($OB_frsclr * 0.3048));

    if ($OB_ratio <= 1) {
      printf OB "<td>%s%s%s</td>", $red, $OB_ratio, $end;
    }
    else {
      printf OB "<td>%s</td>", $OB_ratio;
    }
    print OB "</tr>\n";
  close OB;
  
  unlink "OB.qth";
  undef $distance; undef $OB_HT; undef $OB_TYPE;
}

## Coordinate Cleanup
#
$LAT1_D =~ tr/0-9.//csd;
$LAT1_M =~ tr/0-9.//csd;
$LAT1_S =~ tr/0-9.//csd;

$LON1_D =~ tr/0-9.//csd;
$LON1_M =~ tr/0-9.//csd;
$LON1_S =~ tr/0-9.//csd;

$LAT2_D =~ tr/0-9.//csd;
$LAT2_M =~ tr/0-9.//csd;
$LAT2_S =~ tr/0-9.//csd;

$LON2_D =~ tr/0-9.//csd;
$LON2_M =~ tr/0-9.//csd;
$LON2_S =~ tr/0-9.//csd;

if ($LAT1_D > 72 || $LAT1_D < 17) {
  print "<b>BAD COORDINATES! - $LAT1_D &gt; 72 or $LAT1_D &lt; 17</b>\n";
  exit 1;
}
if ($LAT1_M >= 60) {
  print "<b>BAD COORDINATES! - $LAT1_M &gt; 60</b>\n";
  exit 1;
}
if ($LAT1_S >= 60) {
  print "<b>BAD COORDINATES! - $LAT1_S &gt; 60</b>\n"; 
  exit 1;
}

if ($LON1_D > 180) {
  print "<b>BAD COORDINATES! - $LON1_D &gt; 180</b>\n";
  exit 1;
}
if ($LON1_M >= 60) {
  print "<b>BAD COORDINATES! - $LON1_M &gt; 60</b>\n"; 
  exit 1;
}
if ($LON1_S >= 60) {
  print "<b>BAD COORDINATES! - $LON1_S &gt; 60</b>\n"; 
  exit 1;
}

if ($LAT2_D > 72 || $LAT2_D < 17) {
  print "<b>BAD COORDINATES! - $LAT2_D &gt; 72 or $LAT2_D &lt; 17</b>\n";
  exit 1;
}
if ($LAT2_M >= 60) {
  print "<b>BAD COORDINATES! - $LAT2_M &gt; 60</b>\n";
  exit 1;
}
if ($LAT2_S >= 60) {
  print "<b>BAD COORDINATES! - $LAT2_S &gt; 60</b>\n";
  exit 1;
}

if ($LON2_D > 180) {
  print "<b>BAD COORDINATES! - $LON2_D &gt; 180</b>\n";
  exit 1;
}
if ($LON2_M >= 60) {
  print "<b>BAD COORDINATES! - $LON2_M &gt; 60</b>\n";    
  exit 1;
}
if ($LON2_S >= 60) {
  print "<b>BAD COORDINATES! - $LON2_S &gt; 60</b>\n"; 
  exit 1;
}

$LAT1 = sprintf "%.6f", $LAT1_D + ($LAT1_M / 60) + ($LAT1_S / 3600);
$LON1 = sprintf "%.6f", $LON1_D + ($LON1_M / 60) + ($LON1_S / 3600);

$LAT2 = sprintf "%.6f", $LAT2_D + ($LAT2_M / 60) + ($LAT2_S / 3600);
$LON2 = sprintf "%.6f", $LON2_D + ($LON2_M / 60) + ($LON2_S / 3600);

$check1 = sprintf "%s/%.f:%.f:%.f:%.f.sdf", $splatdir, $LAT1_D, ($LAT1_D + 1), $LON1_D, ($LON1_D + 1);
$check1a = sprintf "%s/%.f:%.f:%.f:%.f.sdf.bz2", $splatdir, $LAT1_D, ($LAT1_D + 1), $LON1_D, ($LON1_D + 1);

$check2 = sprintf "%s/%.f:%.f:%.f:%.f.sdf", $splatdir, $LAT2_D, ($LAT2_D + 1), $LON2_D, ($LON2_D + 1);
$check2a = sprintf "%s/%.f:%.f:%.f:%.f.sdf.bz2", $splatdir, $LAT2_D, ($LAT2_D + 1), $LON2_D, ($LON2_D + 1);

$LAT1_D = sprintf "%02.0f", $LAT1_D;
$LAT1_M = sprintf "%02.0f", $LAT1_M;
$LAT1_S = sprintf "%02.2f", $LAT1_S;

$LON1_D = sprintf "%03.0f", $LON1_D;
$LON1_M = sprintf "%02.0f", $LON1_M;
$LON1_S = sprintf "%02.2f", $LON1_S;

$LAT2_D = sprintf "%02.0f", $LAT2_D;
$LAT2_M = sprintf "%02.0f", $LAT2_M;
$LAT2_S = sprintf "%02.2f", $LAT2_S;

$LON2_D = sprintf "%03.0f", $LON2_D;
$LON2_M = sprintf "%02.0f", $LON2_M;
$LON2_S = sprintf "%02.2f", $LON2_S;

## Path Distance
#
$h = ($LON1 - $LON2) * (68.962 + 0.04525 * (($LAT1 + $LAT2) / 2) - 0.01274 * (($LAT1 + $LAT2) / 2) ** 2 + 0.00004117 * (($LAT1 + $LAT2) / 2) ** 3);
$v = ($LAT1 - $LAT2) * (68.712 - 0.001184 * (($LAT1 + $LAT2) / 2) + 0.0002928 * (($LAT1 + $LAT2) / 2) ** 2 - 0.000002162 * (($LAT1 + $LAT2) / 2) ** 3);
$dist_mi = sprintf "%.2f", sqrt(($h ** 2) + ($v ** 2));
$dist_km = sprintf "%.2f", $dist_mi * 1.609344;

if ($dist_km > 300 || $dist_km <= 0 || !$dist_km) {
  print "<p><b>PATH LENGTH TOO LONG OR TOO SHORT!!</b></p><p>300 km MAX</p><p>$dist_km km USED</p></html>";
  exit 1;
}

## Antenna Heights
#
$tx_ant_ht =~ tr/0-9.//csd;
$rx_ant_ht =~ tr/0-9.//csd;

if (!$tx_ant_ht || !$rx_ant_ht) {
  print "<b>BAD ANTENNA HEIGHT(S)!!</b><br><br>TX: $tx_ant_ht RX: $rx_ant_ht</html>";
  exit 1;
}

if ($tx_ant_ht_val eq "feet") {
  $tx_ant_ht_m = sprintf "%.1f", $tx_ant_ht * 0.3048; # feet to meters
  $tx_ant_ht_ft = sprintf "%.1f", $tx_ant_ht; 
} 
else {
  $tx_ant_ht_m = sprintf "%.1f", $tx_ant_ht;
  $tx_ant_ht_ft = sprintf "%.1f", $tx_ant_ht / 0.3048;
} 

if ($rx_ant_ht_val eq "feet") {
  $rx_ant_ht_m = sprintf "%.1f", $rx_ant_ht * 0.3048; # feet to meters
  $rx_ant_ht_ft = sprintf "%.1f", $rx_ant_ht; 
} 
else {
  $rx_ant_ht_m = sprintf "%.1f", $rx_ant_ht;
  $rx_ant_ht_ft = sprintf "%.1f", $rx_ant_ht / 0.3048;
} 

## Frequency
#
$frq =~ tr/0-9.//csd;

if (!$frq || $frq <= 0) {
  print "<b>ENTER A FREQUENCY!!!</b></html>";
  exit 1;
} 

if ($frq_val eq "GHz") {
  $frq_mhz = sprintf "%.4f", $frq * 1000;
  $frq_ghz = sprintf "%.4f", $frq;
} 
else {
  $frq_mhz = sprintf "%.4f", $frq;
  $frq_ghz = sprintf "%.4f", $frq / 1000;
} 

## Get K Factor
#
if ($k eq "5/12") {
  $k = 5 / 12;
  $k_str = "5/12";
}
elsif ($k eq "1/2") {
  $k = 1 / 2;
  $k_str = "1/2";
}
elsif ($k eq "2/3") {
  $k = 2 / 3;
  $k_str = "2/3";
}
elsif ($k eq "1.0") {
  $k = 1.0;
  $k_str = "1.0";
}
elsif ($k eq "7/6") {
  $k = 7 / 6;
  $k_str = "7/6";
}
elsif ($k eq "4/3") {
  $k = 4 / 3;
  $k_str = "4/3";
}
elsif ($k eq "5/3") {
  $k = 5 / 3;
  $k_str = "5/3";
}
elsif ($k eq "7/4") {
  $k = 7 / 4;
  $k_str = "7/4";
}
elsif ($k eq "2.0") {
  $k = 2.0;
  $k_str = "2.0";
}
elsif ($k eq "4.0") {
  $k = 4.0;
  $k_str = "4.0";
}
elsif ($k eq "Infinity") {
  $k = 10000;
  $k_str = "Infinity";
}

$nunits = 179.3 * (ln ((1 / 0.04665) * (1 - (1 / $k))));
$nunits = sprintf "%.1f", $nunits;

if ($nunits < 250 || $nunits > 400) {
  $nunits = 301;
}

## Print HTML
#
print "<html>\n";
print "<head><title>Microwave Radio Path Analysis</title></head>\n";
print "<body bgcolor=#D3D3D3 text=#000000 link=blue>\n";
print "<center>\n";
print "<h1><font face=Helvetica><i>Microwave Radio Path Analysis</i></font></h1>\n";
print "<p>$banner</p>\n";
print "</center>\n";
print "<hr noshade>\n";
print "<p><b>Generating Path Analysis Report&nbsp;&nbsp;&nbsp;&nbsp;(will take a few moments/minutes)</b> ..<br>";
&flush(STDOUT);

if (!-f "$check1" && !-f "$check1a") {
  print "<p><font color=red><b>Elevation Data Unavailable for $LAT1_D&deg; $LAT1_M' $LAT1_S\"  -  $LON1_D&deg; $LON1_M' $LON1_S\"</b></font></p>\n";
}
if (!-f "$check2" && !-f "$check2a") {
  print "<p><font color=red><b>Elevation Data Unavailable for $LAT2_D&deg; $LAT2_M' $LAT2_S\"  -  $LON2_D&deg; $LON2_M' $LON2_S\"</b></font></p>\n";
}

## Start Splat
#
open TX, "> tx.qth";
  print TX "Transmitter\n".
           "$LAT1\n".
           "$LON1\n".
           "$tx_ant_ht_ft\n";
close TX;

open RX, "> rx.qth";
  print RX "Receiver\n".
           "$LAT2\n".
           "$LON2\n".
           "$rx_ant_ht_ft\n";
close RX;

$tx_name =~ tr/A-Za-z0-9\.\-\ //csd;
$tx_name = sprintf "%.20s", $tx_name;
$rx_name =~ tr/A-Za-z0-9\.\-\ //csd;
$rx_name = sprintf "%.20s", $rx_name;

if (!$tx_name) {
  $tx_name = "Tx";
}
if (!$rx_name) {
  $rx_name = "Rx";
}

$tx_file = $tx_name;
$rx_file = $rx_name;

$tx_file =~ s/ /_/g;
$rx_file =~ s/ /_/g; 

if (!$tx_file) {
  $tx_file = "Tx";
}
if (!$rx_file) {
  $rx_file = "Rx";
}

$outpdf = "$tx_file" . "-to-" . "$rx_file" . ".pdf";

&System($args = "/usr/local/bin/splat -t tx.qth -r rx.qth -p pro.png -l lon.png -d sdf >/dev/null 2>&1");

## Get Elevation Data
#
if (-f "profile.gp") {
  
  $first = `$tail -n 1 profile.gp`;
  ($a, $rx_elv_ft) = split /\t/, $first;
  chomp $rx_elv_ft;
  $rx_elv_m = sprintf "%.1f", $rx_elv_ft * 0.3048;
  $rx_elv_ft = sprintf "%.1f", $rx_elv_ft;

  if ($rx_elv_ft eq "-5000.0") {
    $rx_elv_m = sprintf "%.1f", 0;
    $rx_elv_ft = sprintf "%.1f", 0;
  }

  $last = `$head -n 1 profile.gp`;
  ($a, $tx_elv_ft) = split /\t/, $last;
  chomp $tx_elv_ft;
  $tx_elv_m = sprintf "%.1f", $tx_elv_ft * 0.3048;
  $tx_elv_ft = sprintf "%.1f", $tx_elv_ft; 

  if ($tx_elv_ft eq "-5000.0") {
    $tx_elv_m = sprintf "%.1f", 0;
    $tx_elv_ft = sprintf "%.1f", 0;
  } 

  open F, "profile.gp";
  open F1, "> $elev_tmp1";
  open F2, "> terrain_elv";
    while (<F>) {
      ($a, $b) = split;
      $path = $a * 1.609344;
      $elevation = $b * 0.3048;
      push (@LOWEST, $elevation);
      push (@RANGE, $elevation); 
      printf F1 "%.6f\t%.6f\n", $path, $elevation + (75.5 / $k) * 0.001 * $path * ($dist_km - $path);
      printf F2 "%.6f\t%.6f\n", $path, $elevation;
    }
  close F;
  close F1;
  close F2;
}
else {
  print "<b>Elevation Data Unavailable</b></html>";
  exit 1;
}

## Plot Terrain Profile
#
open F, "> terrain.gp";
  print F "set xlabel \"$tx_name to $rx_name Path Distance ($dist_km kilometers)\"\n";
  print F "set ylabel \"Elevation - Above Mean Sea Level (meters)\"\n";
  print F "set clip\n"; 
  print F "set nokey\n";
  print F "set grid\n";
  print F "set ticscale 2 1\n";
  print F "set mytics\n";
  print F "set mxtics\n";
  print F "set tics out\n";
  print F "set border 0\n";
  print F "set samples 300\n";
  print F "set terminal png color\n";
  print F "set autoscale\n";
  print F "set xrange [0:$dist_km]\n";
  print F "set output \"Terrain.png\"\n";
  print F "plot \"terrain_elv\" with lines lt 6 lw 2\n";
close F;

&System($args = "$gnuplot terrain.gp");

open F, "> usgs_ter.html";
  print F "<html>\n".
          "<body>\n".
	  "<hr noshade>\n".
	  "<center>\n".
	  "<h1><font face=Helvetica color=#82007C><i>SRTM3 Version 2 Terrain Profile Report</i></font></h1>\n".
	  "</center>\n".
	  "<hr noshade>\n".
	  "<center><img src=Terrain.png></center>\n";

  if (!-f "$check1" && !-f "$check1a") {
    print F "<p><font color=red><b>Elevation Data Unavailable for $LAT1_D&deg; $LAT1_M' $LAT1_S\"  -  $LON1_D&deg; $LON1_M' $LON1_S\"</b></font></p>\n";
  }
  if (!-f "$check2" && !-f "$check2a") {
    print F "<p><font color=red><b>Elevation Data Unavailable for $LAT2_D&deg; $LAT2_M' $LAT2_S\"  -  $LON2_D&deg; $LON2_M' $LON2_S\"</b></font></p>\n";
  }

  @sorted1 = sort bynumber @RANGE;
  $lowest1 = pop @sorted1;
 
  @sorted2 = sort bynumber1 @RANGE;
  $highest1 = pop @sorted2;

  foreach $e (@RANGE) {
     $ee += $e;
     $count++;
  }
  $avg_ht = $ee / $count;

  print F "<pre>\n";
  printf F "            <b>Average Elevation :</b> %.1f <b>meters (</b>%.1f <b>feet)</b></p>\n", $avg_ht, $avg_ht * 3.2808399;
  printf F "            <b>Minimum Elevation :</b> %.1f <b>meters (</b>%.1f <b>feet)</b></p>\n", $lowest1, $lowest1 * 3.2808399;
  printf F "            <b>Maximum Elevation :</b> %.1f <b>meters (</b>%.1f <b>feet)</b></p>\n", $highest1, $highest1 * 3.2808399;
  print F "</pre>\n";

  print F "</body>\n";
  print F "</html>\n";
close F;

## Plot Terrain Obstructions
#
if (-f "Transmitter-to-Receiver.txt") {
 
  &System($args = "/bin/cat Transmitter-to-Receiver.txt | sort > Transmitter-to-Receiver1.txt");

  open T, "Transmitter-to-Receiver1.txt";
  open T1, "> ter_obstruct.html";

    print T1 "<html>\n".
             "<body>\n".
             "<hr noshade>\n".
             "<center>\n".
             "<h1><font face=Helvetica color=#82007C><i>Terrain Obstruction Report</i></font></h1>\n".
             "</center>\n".
             "<hr noshade>\n".
	     "<br>\n".
	     "<center><p><b>Potential Ground Obstructions Along the Radio Path</b></p></center>\n".
             "<table border=1 cellpadding=4>\n".
             "<tr>\n".
             "<th><b>Obstruction Latitude (North)</b></th>\n".
             "<th><b>Obstruction Longitude (West)</b></th>\n".
             "<th><b>Distance From Transmitter Site (km)</b></th>\n".
             "<th><b>Ground Elevation AMSL (m)</b></th>\n".
             "</tr>\n";

    while (<T>) {
      next if $_ eq "\n";

      if (/^OBS/) {
        ($a, $b, $c, $d, $e) = split ',';
	print T1 "<tr>\n";
	printf T1 "<td>%.4f</td>\n", $b;
	printf T1 "<td>%.4f</td>\n", $c;
	printf T1 "<td>%.2f</td>\n", abs ($dist_km - ($d * 1.609344));
	printf T1 "<td>%.1f</td>\n", $e * 0.3048;
	print T1 "</tr>\n";
      }

      if (/^HAAT1/) {
        ($a, $tx_haat) = split ':';
	  chomp $tx_haat;
	  $tx_haat_ft = sprintf "%.1f", $tx_haat;
	  $tx_haat_m = sprintf "%.1f", $tx_haat * 0.3048;
      }

      if (/^HAAT2/) {
        ($a, $rx_haat) = split ':';
	chomp $rx_haat;
	$rx_haat_ft = sprintf "%.1f", $rx_haat;
	$rx_haat_m = sprintf "%.1f", $rx_haat * 0.3048;
      }

      if (/^MIN/) {
        ($a, $min) = split ':';
	chomp $min;
        $min_ft = sprintf "%.1f", $min;
	$min_m = sprintf "%.1f", $min * 0.3048;
      }
    }

    print T1 "</table>\n";
    print T1 "</body>\n";
    print T1 "</html>\n";
  close T1;
  close T;
}

if (!$tx_haat_ft) {
  $tx_haat_ft = $tx_haat_m = "N/A";
}

if (!$rx_haat_ft) {
  $rx_haat_ft = $rx_haat_m = "N/A";
}

if (!$min_ft) {
  $min_ft = $min_m = "N/A";
}

$tx_ant_ht_ov_m = sprintf "%.1f", $tx_elv_m + $tx_ant_ht_m;
$rx_ant_ht_ov_m = sprintf "%.1f", $rx_elv_m + $rx_ant_ht_m;
$tx_ant_ht_ov_ft = sprintf "%.1f", $tx_elv_ft + $tx_ant_ht_ft;
$rx_ant_ht_ov_ft = sprintf "%.1f", $rx_elv_ft + $rx_ant_ht_ft;

if ($tx_ant_ht_ov_m > $rx_ant_ht_ov_m) {
  $E1 = $tx_ant_ht_ov_m;
  $E2 = $rx_ant_ht_ov_m;
  $BIG = "yes";
}
else {
  $E1 = $rx_ant_ht_ov_m;
  $E2 = $tx_ant_ht_ov_m;
  $BIG = "no";
}

## Antenna Tilt
#
if ($k_str eq "Infinity" || $dist_km <= 7) {
  $tilt = sprintf "%.4f", rad2deg atan2(abs($tx_ant_ht_ov_ft - $rx_ant_ht_ov_ft), ($dist_mi * 5280));

  if ($tx_ant_ht_ov_ft > $rx_ant_ht_ov_ft) {
    $tilt_tr = sprintf "-%.4f", $tilt;
    $tilt_rt = sprintf "+%.4f", $tilt;
    $dir_tr = "DOWNWARD";
    $dir_rt = "UPWARD";
  }  
  elsif ($rx_ant_ht_ov_ft > $tx_ant_ht_ov_ft) {
    $tilt_tr = sprintf "+%.4f", $tilt;
    $tilt_rt = sprintf "-%.4f", $tilt;
    $dir_tr = "UPWARD";
    $dir_rt = "DOWNWARD";
  }  
  else {
    $tilt_tr = sprintf "%.4f", 0;
    $tilt_rt = sprintf "%.4f", 0;
    $dir_tr = "LEVEL";
    $dir_rt = "LEVEL";
  }  
}
else {
  $TR = (180 / pi) * ((($rx_ant_ht_ov_ft - $tx_ant_ht_ov_ft) / (5280 * $dist_mi)) - ($dist_mi / (7920 * $k)));
  $TR = abs $TR;
  $RT = (180 / pi) * ((($tx_ant_ht_ov_ft - $rx_ant_ht_ov_ft) / (5280 * $dist_mi)) - ($dist_mi / (7920 * $k)));
  $RT = abs $RT;

  if ($tx_ant_ht_ov_ft > $rx_ant_ht_ov_ft) {
    $tilt_tr = sprintf "-%.4f", $TR;
    $dir_tr = "DOWNWARD";
    $tilt_rt = sprintf "+%.4f", $RT;
    $dir_rt = "UPWARD";
  }
  elsif ($tx_ant_ht_ov_ft < $rx_ant_ht_ov_ft) {
    $tilt_tr = sprintf "+%.4f", $TR;
    $dir_tr = "UPWARD";
    $tilt_rt = sprintf "-%.4f", $RT;
    $dir_rt = "DOWNWARD";
  }
  else {
    $tilt_tr = sprintf "%.4f", 0;
    $dir_tr = "LEVEL";
    $tilt_rt = sprintf "%.4f", 0;
    $dir_rt = "LEVEL";
  }
}

## Atmospheric Absorption (oxygen & water vapor loss)
#
$oxy_att_km = ((6.6 / (($frq_ghz ** 2) + 0.33)) + (9 / ((($frq_ghz - 57) ** 2) + 1.96))) * ($frq_ghz ** 2) * (10 ** -3);
$oxy_att_total = $oxy_att_km * $dist_km;

$wvd = 7.5; # water vapor density, gm/m3

$water_att_km = (0.067 + 2.4 / ((($frq_ghz - 22.3) ** 2) + 6.6)) * (($frq_ghz ** 2) * $wvd * (10 ** -4));
$water_att_total = $water_att_km * $dist_km;

$atmos = sprintf "%.2f", $oxy_att_total + $water_att_total;

## Rain Absorption
#
if ($rain eq "B : Polar Taiga (Moderate)") {
  $rate = 19;
  $region = "B";
}
elsif ($rain eq "C : Temperate Maritime") {
  $rate = 28;
  $region = "C";
}
elsif ($rain eq "D1 : Temperate Continental (Dry)") {
  $rate = 37;
  $region = "D1";
}
elsif ($rain eq "D2 : Temperate Continental (Mid)") {
  $rate = 49;
  $region = "D2";
}
elsif ($rain eq "D3 : Temperate Continental (Wet)") {
  $rate = 63;
  $region = "D3";
}
elsif ($rain eq "E : Sub Tropical Wet") {
  $rate = 98;
  $region = "E";
}
elsif ($rain eq "F : Sub Tropical Arid") {
  $rate = 23;
  $region = "F";
}

#$Ah = (-0.008001 * $frq_ghz) + 1.258;
#$Kh = 0.0000351298 * ($frq_ghz ** 2.539);
#$ATTh = $Kh * ($rate ** $Ah);
#$ATTv = (300 * $ATTh) / (335 + $ATTh);
#$EffDistKM = $dist_km / (1 + (0.045 * $dist_km));
#$ATTh_Total = sprintf "%.2f", $ATTh * $EffDistKM;
#$ATTv_Total = sprintf "%.2f", $ATTv * $EffDistKM;

#$EffDistKM = sprintf "%.2f", $EffDistKM;
#$EffDistMI = sprintf "%.2f", $EffDistKM * 0.62137119;

if ($frq_ghz >= 2) {
  if ($frq_ghz >= 2 && $frq_ghz <= 54) {
    $af = 4.21 * (10 ** -5) * ($frq_ghz ** 2.42);
  }
  elsif ($frq_ghz > 54 && $frq_ghz <= 180) {
    $af = 4.09 * (10 ** -2) * ($frq_ghz ** 0.699);
  } 
  if ($frq_ghz >= 2 && $frq_ghz <= 25) {
    $bf = 1.41 * ($frq_ghz ** -0.0779);
  }
  elsif ($frq_ghz > 25 && $frq_ghz <= 180) {
    $bf = 2.63 * ($frq_ghz ** -0.272);
  } 
    $rain_att_km = sprintf "%.3f", $af * ($rate ** $bf);
    $rain_att_mi = sprintf "%.3f", $rain_att_km / 1.609344;
    $rain_eff_km = sprintf "%.2f", $dist_km / (1 + (0.045 * $dist_km));
    $rain_eff_mi = sprintf "%.2f", $rain_eff_km / 1.609344;
    $rain_att_total = sprintf "%.2f", $rain_att_km * $rain_eff_km;
  } 
else {
  $rain_att_km = sprintf "%.3f", 0;
  $rain_att_mi = sprintf "%.3f", 0;
  $rain_eff_km = sprintf "%.2f", 0;
  $rain_eff_mi = sprintf "%.2f", 0;
  $rain_att_total = sprintf "%.2f", 0;
} 

## Free Space Path Loss
#
$fs = sprintf "%.2f", (20 * (log10 $frq_mhz)) + (20 * (log10 $dist_km)) + 32.447782;

## Excess Path Loss
#
$exc = sprintf "%.2f", abs (20 * log10(2.25 / $dist_km));

## Earth Curve
#
open E, "> $elev_tmp2";
  @sorted = sort bynumber @LOWEST;
  $lowest = pop @sorted;
  $Hft = (2 * (($dist_km / 2) * 0.62137119) * (($dist_km * 0.62137119) - (($dist_km / 2) * 0.62137119))) / (3 * $k);
  printf E "%.3f\t%.3f\n", 0, $lowest - 1;
  printf E "%.3f\t%.3f\n", $dist_km / 2, ($lowest - 1) + ($Hft * 0.3048);
  printf E "%.3f\t%.3f\n", $dist_km, $lowest - 1; 
close E; 

## Reference Line
#
open R, "> $elev_tmp3";
  printf R "%.2f\t%.2f\n", 0, $tx_ant_ht_ov_m;
  printf R "%.2f\t%.2f\n", $dist_km, $rx_ant_ht_ov_m;
close F;

## 0.6 Fresnel
#
$step = $dist_km * 0.005;

open F4, "> $elev_tmp4" || die "Can't open $elev_tmp4: $!";
  
    if ($BIG eq "yes") {
      for ($pl = $step; $pl <= ($dist_km - $step); $pl = $pl + $step) {
        $A = $pl * (($E1 - $E2) / $dist_km);
        $f1 = 72.1 * sqrt((($pl * 0.62137119) * (($dist_km - $pl) * 0.62137119)) / (($frq_mhz / 1000) * ($dist_km * 0.62137119))) * 0.6; 
        printf F4 "%.3f\t%.3f\n", $pl, ($tx_ant_ht_ov_m - $A) - ($f1 * 0.3048);
      }
    } 
    else {
      for ($pl = $step; $pl <= ($dist_km - $step); $pl = $pl + $step) {
        $A = $pl * (($E1 - $E2) / $dist_km);
	$f1 = 72.1 * sqrt((($pl * 0.62137119) * (($dist_km - $pl) * 0.62137119)) / (($frq_mhz / 1000) * ($dist_km * 0.62137119))) * 0.6;
       printf F4 "%.3f\t%.3f\n", $pl, ($tx_ant_ht_ov_m + $A) - ($f1 * 0.3048);
      }
    } 

close F4;

$step = ($dist_km * 1000) / 200;

## $nth Fresnel
#
if ($nth eq "None") {
  # deleted
}
else {
  open F5, "> $elev_tmp5" || die "Can't open $elev_tmp5: $!";

      if ($BIG eq "yes") {
        for ($pl = $step; $pl <= (($dist_km * 1000) - $step); $pl = $pl + $step) {
          $A = ($pl / 1000) * (($E1 - $E2) / $dist_km);
          $f1 = 17.31 * sqrt (($nth * ($pl * (($dist_km * 1000) - $pl))) / ($frq_mhz * ($dist_km * 1000)));
          printf F5 "%.3f\t%.3f\n", ($pl / 1000), ($tx_ant_ht_ov_m - $A) - $f1;
        }
      }
      else {
        for ($pl = $step; $pl <= (($dist_km * 1000) - $step); $pl = $pl + $step) {
          $A = ($pl / 1000) * (($E1 - $E2) / $dist_km);
          $f1 = 17.31 * sqrt (($nth * ($pl * (($dist_km * 1000) - $pl))) / ($frq_mhz * ($dist_km * 1000)));
          printf F5 "%.3f\t%.3f\n", ($pl / 1000), ($tx_ant_ht_ov_m + $A) - $f1;
        } 
      }
  close F5;
}

## Azimuth
#
$lat1_az = deg2rad $LAT1;
$lon1_az = deg2rad ($LON1 * -1);
$lat2_az = deg2rad $LAT2; 
$lon2_az = deg2rad ($LON2 * -1);

$cosd = sin($lat2_az) * sin($lat1_az) + cos($lat1_az) * cos($lat2_az) * cos($lon1_az - $lon2_az);
$daz = rad2deg (acos $cosd);
$cosb = (sin($lat2_az) - sin($lat1_az) * cos (deg2rad($daz))) / (cos($lat1_az) * sin (deg2rad($daz)));

if ($cosb > 0.999999) {
  $AZ = 0;
} 
elsif ($cosb < -0.999999) {
  $AZ = 180; 
} 
else {
  $AZ = rad2deg (acos $cosb);
} 
       
if (sin ($lon2_az - $lon1_az) >= 0) {
  $AZSP = $AZ;
  $AZLP = 180 + $AZ;
} 
else {
  $AZSP = 360 - $AZ;
  $AZLP = 180 - $AZ;
} 

$AZSP = sprintf "%.2f", $AZSP;
$AZLP = sprintf "%.2f", $AZLP;

  #print F "             Minimum Transmitter Antenna Height : $min_m meters ($min_ft feet)\n";
  print F "\n\n\n\n";
  print F "<b>Calculated on $mon/$mday/$year      URL: $url $ver</b>\n";
  print F "</pre>\n";
  print F "</body>\n";
  print F "</html>\n";
close F;

## Terrain Profile GNUplot
#
open G, "> $elev_tmp8";
  print G "set xlabel \"$tx_name to $rx_name Path Distance ($dist_km kilometers)\"\n";
  print G "set ylabel \"Elevation - Above Mean Sea Level (meters)\"\n";
  print G "set clip\n";
  print G "set key below\n";
  print G "set ticscale 2 1\n";
  print G "set mytics\n";
  print G "set mxtics\n";
  print G "set tics out\n";
  print G "set border 0\n";
  print G "set samples 300\n";
  print G "set terminal png color\n";
  print G "set autoscale\n";
  print G "set xrange [0:$dist_km]\n";
  printf G "set arrow from %s,%s to %s,%s nohead lt -1 lw 3\n", 0, $tx_elv_m, 0, $tx_ant_ht_ov_m;
  printf G "set arrow from %s,%s to %s,%s nohead lt -1 lw 3\n", $dist_km, $rx_elv_m, $dist_km, $rx_ant_ht_ov_m;

  open OB, "> path_obstruct.html";

  print OB "<html>\n".
           "<body>\n".
           "<hr noshade>\n".
           "<center>\n".
           "<h1><font face=Helvetica color=#82007C><i>Path Obstruction Report</i></font></h1>\n".
           "</center>\n".
           "<hr noshade>\n".
	   "<br>\n".
	   "<center><p><b>B = Building&nbsp;&nbsp;&nbsp;&nbsp;T = Tree</b></p></center>\n".
           "<table border=1 cellpadding=4>\n".
           "<tr>\n".
	   "<th><b>Tx to Rx<br>Distance (km)</b></th>\n".
           "<th><b>Ground<br>Elevation (m)</b></th>\n".
	   "<th><b>Obstruction<br>Height (m)</b></th>\n".
           "<th><b>$k_str Earth<br>Curvature (m)</b></th>\n".
           "<th><b>Signal<br>Clearance (m)</b></th>\n".
           "<th><b>0.6 Fresnel<br>Radius (m)</b></th>\n".
           "<th><b>0.6 Fresnel<br>Clearance (m)</b></th>\n".
           "<th><b>Signal/Fresnel<br>Ratio</b></th>\n".
           "</tr>\n";
  close OB;

  if ($EE_DIS && $EE_HT) {
    &Obst($distance = $EE_DIS, $OB_HT = $EE_HT, $OB_TYPE = $EE_TYPE);
  }

  if ($FF_DIS && $FF_HT) {
    &Obst($distance = $FF_DIS, $OB_HT = $FF_HT, $OB_TYPE = $FF_TYPE);
   } 

  if ($GG_DIS && $GG_HT) {
    &Obst($distance = $GG_DIS, $OB_HT = $GG_HT, $OB_TYPE = $GG_TYPE);
  }      

  if ($HH_DIS && $HH_HT) {
    &Obst($distance = $HH_DIS, $OB_HT= $HH_HT, $OB_TYPE= $HH_TYPE);
  }

  if ($II_DIS && $II_HT) {
    &Obst($distance = $II_DIS, $OB_HT = $II_HT, $OB_TYPE = $II_TYPE);
  }

  if ($JJ_DIS && $JJ_HT) {
    &Obst($distance = $JJ_DIS, $OB_HT = $JJ_HT, $OB_TYPE = $JJ_TYPE);
  }

  if ($KK_DIS && $KK_HT) {
    &Obst($distance = $KK_DIS, $OB_HT = $KK_HT, $OB_TYPE = $KK_TYPE);
  }       

  if ($LL_DIS && $LL_HT) {
    &Obst($distance = $LL_DIS, $OB_HT = $LL_HT, $OB_TYPE = $LL_TYPE);
  }

  if ($MM_DIS && $MM_HT) {
    &Obst($distance = $MM_DIS, $OB_HT = $MM_HT, $OB_TYPE = $MM_TYPE);
  }

  if ($NN_DIS && $NN_HT) {
    &Obst($distance = $NN_DIS, $OB_HT = $NN_HT, $OB_TYPE = $NN_TYPE);
  }

  open OB, ">> path_obstruct.html";
    print OB "</table>\n";
    print OB "</body>\n";
    print OB "</html>\n";
  close OB;

  print G "set output \"Path_Analysis.png\"\n";

  if ($nth eq "None") {
    print G "plot \"$elev_tmp1\" title 'SRTM3/Ground' with lines lt 6 lw 2, ".
            "\"$elev_tmp2\" smooth csp title '$k_str Earth Curve' lt 3 lw 2, ".
            "\"$elev_tmp3\" title '$frq_ghz GHz Reference' with lines lt 8 lw 2, ".
            "\"$elev_tmp4\" smooth csp title '0.6 Fresnel' lt 1 lw 2\n";
    close G;
  }
  else {
    print G "plot \"$elev_tmp1\" title 'SRTM3/Ground' with lines lt 6 lw 2, ".
            "\"$elev_tmp2\" smooth csp title '$k_str Earth Curve' lt 3 lw 2, ".
            "\"$elev_tmp3\" title '$frq_ghz GHz Reference' with lines lt 8 lw 2, ".
            "\"$elev_tmp4\" smooth csp title '0.6 Fresnel' lt 1 lw 2, ".
            "\"$elev_tmp5\" smooth csp title '$nth Fresnel' lt 2 lw 2\n";
    close G;
  }

&System($args = "$gnuplot $elev_tmp8");

open TP, "> profile.html";
  print TP "<html>\n".
           "<body>\n".
           "<hr noshade>\n".
           "<center>\n".
           "<h1><font face=Helvetica color=#82007C><i>Path Analysis Report</i></font></h1>\n".
           "</center>\n".
           "<hr noshade>\n".
	   "<center><img src=Path_Analysis.png></center>\n".
           "</body>\n".
	   "</html>\n";
close TP;

## Signal Clearance Report
#
open F, "profile.gp";
  while (<F>) {
  $i++
  }
close F;

$cnt_1 = $i - 1;
$cnt_2 = $i - 2;

&System($args = "$tail -n $cnt_1 profile.gp | $head -n $cnt_2 > profile1.gp");

open S, "profile1.gp";
open S1, "> sig_clear.html";

   print S1 "<html>\n".
            "<body>\n".
            "<hr noshade>\n".
            "<center>\n".
            "<h1><font face=Helvetica color=#82007C><i>Signal Clearance Report</i></font></h1>\n".
            "</center>\n".
            "<hr noshade>\n".
	    "<br>\n".
	    "<center><p><b>Main Signal and Fresnel Clearance Along the Radio Path</b></p></center>\n".
            "<table border=1 cellpadding=4>\n".
            "<tr>\n".
            "<th><b>Tx to Rx<br>Distance (km)</b></th>\n".
            "<th><b>Ground<br>Elevation (m)</b></th>\n".
            "<th><b>$k_str Earth<br>Curvature (m)</b></th>\n".
            "<th><b>Signal<br>Clearance (m)</b></th>\n".
            "<th><b>0.6 Fresnel<br>Radius (m)</b></th>\n".
            "<th><b>0.6 Fresnel<br>Clearance (m)</b></th>\n".
	    "<th><b>Signal/Fresnel<br>Ratio</b></th>\n".
            "</tr>\n";

   if ($tx_ant_ht_ov_ft > $rx_ant_ht_ov_ft) {
     $BIG = "yes";
   }       
   else {  
     $BIG = "no";
   }

   while (<S>) {
     chomp;
     ($path, $elev) = split;

     $curv = ($path * ($dist_mi - $path)) / (1.5 * $k);

     if ($curv < 0) {
       $curv = 0;
     }

     if ($BIG eq "yes") {
       $A = $path * (($tx_ant_ht_ov_ft - $rx_ant_ht_ov_ft) / $dist_mi);
       $sigclr = sprintf "%.1f", (($tx_ant_ht_ov_ft - $A) - ($elev + $curv)) * 0.3048;
     }
     else {
       $A = $path * (($rx_ant_ht_ov_ft - $tx_ant_ht_ov_ft) / $dist_mi);
       $sigclr = sprintf "%.1f", (($tx_ant_ht_ov_ft + $A) - ($elev + $curv)) * 0.3048; 
     } 

     $C = ($path * ($dist_mi - $path)) / ($frq_ghz * $dist_mi);

     if ($C < 0) {
       $C = 0;
     }

     $frs = (72.1 * 0.6 * sqrt($C)) * 0.3048;
      
     $frsclr = sprintf "%.1f", $sigclr - $frs;

     if ($frs != 0) {
       $ratio = $sigclr / $frs;
       $ratio = sprintf "%.1f", $ratio;
     }
     else {
       $ratio = 0;
       $ratio = sprintf "%.1f", $ratio;
     }

     print S1 "<tr>\n";
     printf S1 "<td>%.2f</td>", $path * 1.609344;
     printf S1 "<td>%.1f</td>", $elev * 0.3048;
     printf S1 "<td>%.2f</td>", $curv * 0.3048;

     if ($sigclr <= 0) {
       printf S1 "<td>%s%s%s</td>", $red, $sigclr, $end;
     }
     else {
       printf S1 "<td>%s</td>", $sigclr;
     }
      
     push (@ADDITIONAL, $sigclr);
     printf S1 "<td>%.1f</td>", $frs;

     if ($frsclr <= 0) {
       printf S1 "<td>%s%s%s</td>", $red, $frsclr, $end;
     }
     else {
       printf S1 "<td>%s</td>", $frsclr;
     }

     push (@ADDITIONAL, $frsclr);

     if ($ratio <= 1) {
       printf S1 "<td>%s%s%s</td>", $red, $ratio, $end;
     }
     else {
       printf S1 "<td>%s</td>", $ratio;
     }
     print S1 "</tr>\n";
   }
  print S1 "</table>\n";
  print S1 "</body>\n";
  print S1 "</html>\n";
close S1;
close S;

@ADDITIONAL2 = sort bynumber @ADDITIONAL;
$add_ant_low = pop @ADDITIONAL2;

if ($add_ant_low < 0) {
  $add_ant_m = sprintf "%.1f", abs $add_ant_low;
  $add_ant_ft = sprintf "%.1f", abs ($add_ant_low / 0.3048);
}
else {
  $add_ant_m = sprintf "%.1f", 0;
  $add_ant_ft = sprintf "%.1f", 0;
}

## Fresnel Zone Report
#
$step = ($dist_km * 1000) / 200; # meters

open F1, "> Fresnel_TMP1";
open F2, "> Fresnel_TMP2";

for ($pl = $step; $pl <= (($dist_km * 1000) - $step); $pl = $pl + $step) {
  $f1 = 17.31 * sqrt ((0.6 * ($pl * (($dist_km * 1000) - $pl))) / ($frq_mhz * ($dist_km * 1000)));
  $f2 = 17.31 * sqrt (($nth * ($pl * (($dist_km * 1000) - $pl))) / ($frq_mhz * ($dist_km * 1000)));
  printf F1 "%.2f\t%.2f\n", ($pl / 1000), $f1;
  printf F2 "%.2f\t%.2f\n", ($pl / 1000), $f2;
} 
close F1;
close F2;

$d1 = $d2 = (($dist_km * 1000) / 2);

$f1_pk = 17.31 * sqrt ((0.6 * ($d1 * $d2)) / ($frq_mhz * ($dist_km * 1000)));
$f2_pk = 17.31 * sqrt (($nth * ($d1 * $d2)) / ($frq_mhz * ($dist_km * 1000)));

if ($nth < 0.6) {
  $yrange = sprintf "%.f", $f1_pk + 5;
}

if ($nth > 0.6) {
  $yrange = sprintf "%.f", $f2_pk + 5;
}

open F, "> Fresnel_TMP3";
  print F "set xlabel \"$tx_name to $rx_name Path Distance ($dist_km kilometers)\"\n";
  print F "set ylabel \"Fresnel Zone Radius (meters)\"\n";
  print F "set clip\n";  
  print F "set key below\n";
  print F "set grid\n";
  print F "set ticscale 2 1\n";
  print F "set mytics\n";
  print F "set mxtics\n";
  print F "set tics out\n";
  print F "set border 0\n";
  print F "set samples 300\n";
  print F "set terminal png color\n";
  print F "set xrange [0:$dist_km]\n";
  print F "set yrange [$yrange:0]\n";
  print F "set output \"Fresnel_Zone.png\"\n";

  if ($nth eq "None") {
    print F "plot \"Fresnel_TMP1\" smooth csplines title '0.6 Fresnel' lt 1 lw 2\n";
  }
  else {
    print F "plot \"Fresnel_TMP1\" smooth csplines title '0.6 Fresnel' lt 1 lw 2,".
            "\"Fresnel_TMP2\" smooth csplines title '$nth Fresnel' lt 2 lw 2\n";
  } 
close F;

&System($args = "$gnuplot Fresnel_TMP3");

open F, "> fresnel.html";
  print F "<html>\n".
          "<body>\n".
          "<hr noshade>\n".
          "<center>\n".
          "<h1><font face=Helvetica color=#82007C><i>Fresnel Zone Report</i></font></h1>\n".
          "</center>\n".
          "<hr noshade>\n".
          "<center><img src=Fresnel_Zone.png></center>\n".
          "</body>\n".
          "</html>\n";
close F;

## Longley-Rice Report
#
# Get Earth Dielectric Constant
#
$diecon =~ tr/0-9.//csd;

if (!$diecon || $diecon < 1 || $diecon > 81) {
  $diecon = 15;
}

## Get Earth Conductivity
#
$earcon =~ tr/0-9.//csd;

if (!$earcon || $earcon <= 0 || $earcon > 10) {
  $earcon = 0.005;
}

if ($climate eq "Equatorial") {
  $cli = 1;
}
elsif ($climate eq "Continental Subtropical") {
  $cli = 2;
}
elsif ($climate eq "Maritime Subtropical") {
  $cli = 3;
}
elsif ($climate eq "Desert") {
  $cli = 4;
}
elsif ($climate eq "Continental Temperate") {
  $cli = 5;
}
elsif ($climate eq "Maritime Temperate, Overland") {
  $cli = 6;
}
elsif ($climate eq "Maritime Temperate, Oversea") {
  $cli = 7;
}

if ($polar eq "Vertical") {
  $ant = 1;
}
else {
  $ant = 0;
}

if ($sit eq "3 %") {
  $si = 0.03;
}
elsif ($sit eq "10 %") {
  $si = 0.10;
}
elsif ($sit eq "20 %") {
  $si = 0.20;
} 
elsif ($sit eq "30 %") {
  $si = 0.30;
}
elsif ($sit eq "40 %") {
  $si = 0.40;
} 
elsif ($sit eq "50 %") {
  $si = 0.50;
} 
elsif ($sit eq "60 %") {
  $si = 0.60;
}
elsif ($sit eq "70 %") {
  $si = 0.70;
}
elsif ($sit eq "80 %") {
  $si = 0.80;
}
elsif ($sit eq "90 %") {
  $si = 0.90;
}
elsif ($sit eq "97 %") {
  $si = 0.97;
}

if ($time eq "3 %") {
  $ti = 0.03;
} 
elsif ($time eq "10 %") {
  $ti = 0.10;
} 
elsif ($time eq "20 %") {
  $ti = 0.20;
} 
elsif ($time eq "30 %") {
  $ti = 0.30;
} 
elsif ($time eq "40 %") {
  $ti = 0.40;
} 
elsif ($time eq "50 %") {
  $ti = 0.50;
} 
elsif ($time eq "60 %") {
  $ti = 0.60;
} 
elsif ($time eq "70 %") {
  $ti = 0.70;
} 
elsif ($time eq "80 %") {
  $ti = 0.80;
} 
elsif ($time eq "90 %") {
  $ti = 0.90;
} 
elsif ($time eq "97 %") {
  $ti = 0.97;
} 

open LR, "> tx.lrp";
  print LR "$diecon\n".
           "$earcon\n".
           "$nunits\n".
           "$frq_mhz\n".
           "$cli\n".
	   "$ant\n".
	   "$si\n".
	   "$ti\n";
close LR; 

if (-f "longley.gp") {
  
  $lr = `$tail -n 1 longley.gp`;
  ($a, $lrpath) = split /\t/, $lr;
  chomp $lrpath;
  $lrpath = sprintf "%.2f", $lrpath;

  open LR, "longley.gp";
    while (<LR>) {
      ($a, $b) = split;
      $dist = $a * 1.609344;
      push (@PATH, $dist);
      push (@LOSS, $b);
    }
  close F;

  @LONGSRT = sort bynumber1 @PATH;

  open LR, "> longley1.gp";
    while (@LONGSRT) {
      $dist = pop @LONGSRT;
      $loss = pop @LOSS;
      printf LR "%.6f\t%.6f\n", $dist, $loss;
  }
  close LR;
}

else {
  print "<b>Longley-Rice Path Analysis Unavailable</b>";
}

open F, "> Longley_TMP";
  print F "set xlabel \"$tx_name to $rx_name Path Distance ($dist_km kilometers)\"\n";
  print F "set ylabel \"Estimated Longley-Rice Path Loss (dB)\"\n";
  print F "set clip\n";
  print F "set nokey\n";
  print F "set grid\n";
  print F "set ticscale 2 1\n";
  print F "set mytics\n";
  print F "set mxtics\n";
  print F "set tics out\n";
  print F "set border 0\n";
  print F "set samples 300\n";
  print F "set terminal png color\n";
  print F "set autoscale\n";
  print F "set xrange [0:$dist_km]\n";
  print F "set output \"Longley.png\"\n";
  print F "plot \"longley1.gp\" with lines lt 8 lw 2\n";
close F;

&System($args = "$gnuplot Longley_TMP");

open F, "> long.html";
  print F "<html>\n".
          "<body>\n".
          "<hr noshade>\n".
          "<center>\n".
          "<h1><font face=Helvetica color=#82007C><i>Longley-Rice Path Loss Report</i></font></h1>\n".
          "</center>\n".
          "<hr noshade>\n".
          "<center><img src=Longley.png></center>\n";
  print F "<pre>\n";
  printf F "                 <b>Ground Dielectric Constant :</b> %.1f <b>(Relative Permittivity)</b></p>\n", $diecon;
  printf F "                       <b>Ground Conductivity  :</b> %.3f <b>S/m</b></p>\n", $earcon;
  printf F "                               <b>Climate Type :</b> %s</p>\n", $climate;
  printf F "            <b>Index of Atmospheric Refraction :</b> %s <b>N-units (parts per million)</b></p>\n", $nunits;
  printf F "                       <b>Antenna Polarization :</b> %s</p>\n", $polar;
  printf F "         <b>Confidence / Situation Variability :</b> %s</p>\n", $sit;
  printf F "             <b>Reliability / Time Variability :</b> %s</p>\n", $time;
  print F "</pre>\n";
  print F "</body>\n";
  print F "</html>\n";
close F;

## HTML Report
#
open F, "> main.html";
  print F "<html>\n";
  print F "<head></head>\n";
  print F "<body>\n";
  print F "<center>\n";
  print F "<hr noshade>\n";
  print F "<h1><font face=Helvetica color=#82007C><i>Microwave Radio Path Analysis</i></font></h1>\n";
  print F "<p><img src=$logo></p>\n";
  print F "<p>$banner</p>\n";
  print F "</center>\n";
  print F "<hr noshade>\n";
  print F "<pre>\n";
  print F "<b>             Transmitter Site Name :</b> $tx_name\n";
  print F "<b>         Transmitter Site Latitude :</b> $LAT1<b>&deg;  (</b>$LAT1_D<b>&deg;</b> $LAT1_M<b>'</b> $LAT1_S<b>&quot;) North</b>\n";
  print F "<b>        Transmitter Site Longitude :</b> $LON1<b>&deg;  (</b>$LON1_D<b>&deg;</b> $LON1_M<b>'</b> $LON1_S<b>&quot;) West</b>\n";
  print F "<b> Transmitter Site Ground Elevation :</b> $tx_elv_m <b>meters  (</b>$tx_elv_ft <b>feet) AMSL</b>\n";
  print F "\n";
  print F "<b>                Receiver Site Name :</b> $rx_name\n";
  print F "<b>            Receiver Site Latitude :</b> $LAT2<b>&deg;  (</b>$LAT2_D<b>&deg;</b> $LAT2_M<b>'</b> $LAT2_S<b>&quot;) North</b>\n";
  print F "<b>           Receiver Site Longitude :</b> $LON2<b>&deg;  (</b>$LON2_D<b>&deg;</b> $LON2_M<b>'</b> $LON2_S<b>&quot;) West</b>\n";
  print F "<b>    Receiver Site Ground Elevation :</b> $rx_elv_m <b>meters  (</b>$rx_elv_ft <b>feet) AMSL</b>\n";
  print F "\n";
  print F "<b>               Total Path Distance :</b> $dist_km <b>kilometers  (</b>$dist_mi <b>miles)</b>\n";
  print F "\n";
  print F "<b>              Free Space Path Loss :</b> $fs <b>dB</b>\n";
  print F "<b>            Longley-Rice Path Loss :</b> $lrpath <b>dB</b>\n";
  #print F "<b>                  Excess Path Loss :</b> $exc <b>dB</b>\n";
  print F "<b>            Atmospheric Absorption :</b> $atmos <b>dB</b>\n";
  print F "<b>        Worst Case Rain Absorption :</b> $rain_att_total <b>dB</b>\n";
  print F "<b>                       Rain Region :</b> $region <b>  (</b>$rate <b>mm/hr)</b>\n";
  print F "<b>           Effective Rain Distance :</b> $rain_eff_km <b>kilometers  (</b>$rain_eff_mi <b>miles)</b>\n";
  print F "\n";
  print F "<b>     Highest Transmitted Frequency :</b> $frq_ghz <b>GHz  (</b>$frq_mhz <b>MHz)</b>\n";
  print F "<b> Effective Earth Radius (K Factor) :</b> $k_str\n";
  print F "\n";
  print F "<b>        Transmitter Antenna Height :</b> $tx_ant_ht_m <b>meters  (</b>$tx_ant_ht_ft <b>feet) AGL Center-of-Rad.</b>\n";
  print F "<b>Overall Transmitter Antenna Height :</b> $tx_ant_ht_ov_m <b>meters  (</b>$tx_ant_ht_ov_ft <b>feet) AMSL</b>\n";
  print F "\n";
  print F "<b>           Receiver Antenna Height :</b> $rx_ant_ht_m <b>meters  (</b>$rx_ant_ht_ft <b>feet) AGL Center-of-Rad.</b>\n";
  print F "<b>   Overall Receiver Antenna Height :</b> $rx_ant_ht_ov_m <b>meters  (</b>$rx_ant_ht_ov_ft <b>feet) AMSL</b>\n";
  print F "\n";
  print F "<b>Transmitter to Receiver Antenna Mechanical Tilt :</b> $tilt_tr<b>&deg;  (</b>$dir_tr<b>)</b>\n";
  print F "<b>Receiver to Transmitter Antenna Mechanical Tilt :</b> $tilt_rt<b>&deg;  (</b>$dir_rt<b>)</b>\n";
  print F "<b> Azimuth From Transmitter Site to Receiver Site :</b> $AZSP<b>&deg; East of true North</b>\n";
  print F "<b> Azimuth From Receiver Site to Transmitter Site :</b> $AZLP<b>&deg; East of true North</b>\n";
  print F "\n";
  print F "<b>  Transmitter Site Height Above Average Terrain :</b> $tx_haat_m<b> meters (</b>$tx_haat_ft <b>feet)</b>\n";
  print F "<b>     Receiver Site Height Above Average Terrain :</b> $rx_haat_m<b> meters (</b>$rx_haat_ft <b>feet)</b>\n";
  print F "<b>             Additional Required Antenna Height :</b> $add_ant_m<b> meters (</b>$add_ant_ft <b>feet)</b>\n";
  print F "\n\n\n";
  print F "<b>Calculated on $mon/$mday/$year      URL: $url $ver</b>\n";
  print F "</pre>\n";
  print F "</body>\n";
  print F "</html>\n";
close F;

# Display Data
#
print "<center><img src=tmp/$mon-$mday/$RAN/Path_Analysis.png></center>\n";
&flush(STDOUT);
print "<hr noshade>\n";
&flush(STDOUT);
print "<blockquote><b>Generating Signal Clearance PDF Report ...</b></blockquote>\n";
&flush(STDOUT);

$ENV{HTMLDOC_NOCGI}=1;
&System($args = "$htmldoc --links --header ... --linkcolor blue --linkstyle plain --footer ..1 --jpeg=70 --compression=9 -t pdf13 --quiet --webpage -f $outpdf main.html profile.html usgs_ter.html fresnel.html long.html ter_obstruct.html sig_clear.html path_obstruct.html");

$size = (-s $outpdf);
print "<blockquote><center><a href=tmp/$mon-$mday/$RAN/$outpdf>Microwave Radio Path Analysis</a>&nbsp;&nbsp;&nbsp;($outpdf&nbsp;&nbsp;&nbsp;$size bytes)</center></blockquote>\n";
&flush(STDOUT);
print "<hr noshade>\n";
&flush(STDOUT);
print "<blockquote><b>Links to Topographical Maps via <a href=http://www.topozone.com>TopoZone.com</a> ...</b></blockquote>\n";
&flush(STDOUT);
print "<blockquote><center><a href=\"http://www.topozone.com/map.asp?lat=$LAT1&lon=-$LON1\">$tx_name</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"http://www.topozone.com/map.asp?lat=$LAT2&lon=-$LON2\">$rx_name</a></center></blockquote>\n";
&flush(STDOUT);
print "<hr noshade>\n";
&flush(STDOUT);
print "<blockquote><b>Links to Street Maps via <a href=http://tiger.census.gov>TIGER.census.gov</a> ...</b></blockquote>\n";
&flush(STDOUT);
print "<blockquote><center><a href=\"http://tiger.census.gov/cgi-bin/mapsurfer?act=in&infact=2&map.x=211&map.y=180&lat=$LAT1&lon=-$LON1&wid=0.360&ht=0.130&iht=359&iwd=422&&on=streets&on=interstate&on=statehwy&on=ushwy&tlevel=-&tvar=-&tmeth=i&mlat=$LAT1&mlon=-$LON1&msym=bigdot&mlabel=Transmitter&murl=&conf=mapnew.con\">$tx_name</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"http://tiger.census.gov/cgi-bin/mapsurfer?act=in&infact=2&map.x=211&map.y=180&lat=$LAT2&lon=-$LON2&wid=0.360&ht=0.130&iht=359&iwd=422&&on=streets&on=interstate&on=statehwy&on=ushwy&tlevel=-&tvar=-&tmeth=i&mlat=$LAT2&mlon=-$LON2&msym=bigdot&mlabel=Receiver&murl=&conf=mapnew.con\">$rx_name</a></center></blockquote>\n";
&flush(STDOUT);

print "<hr noshade>\n";
&flush(STDOUT);

print "<blockquote><center>Be sure to try the <a href=http://gbppr.dyndns.org:8080/wireless.super.main.cgi>Wireless Network Link Analysis</a> program.</center></blockquote>\n";
&flush(STDOUT);

print "</body>\n";
&flush(STDOUT);
print "</html>\n";
&flush(STDOUT);

## Done
#
if ($DEBUG == 1) {
  unlink $elev_tmp1, $elev_tmp2, $elev_tmp3, $elev_tmp4, $elev_tmp5, $elev_tmp8;
  unlink "profile.gp","profile1.gp","sdf","terrain_elv","terrain.gp","Terrain.png","usgs_ter.html";
  unlink "main.html","profile.html","ter_obstruct.html","sig_clear.html","path_obstruct.html","rx.qth","tx.qth";
  unlink "Fresnel_TMP1","Fresnel_TMP2","Fresnel_TMP3","fresnel.html","Fresnel_Zone.png";
  unlink "long.html","longley1.gp","longley.gp","Longley.png","Longley_TMP","tx.lrp","Transmitter-to-Receiver.lro";
  unlink "Transmitter-to-Receiver1.txt","Transmitter-to-Receiver.txt";
}

exit 0;

